#ifndef SBK_KAutoSaveFileWrapper_H
#define SBK_KAutoSaveFileWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <kautosavefile.h>

namespace PySide { class DynamicQMetaObject; }

class KAutoSaveFileWrapper : public KAutoSaveFile
{
public:
    KAutoSaveFileWrapper(const KAutoSaveFileWrapper &) = delete;
    KAutoSaveFileWrapper& operator=(const KAutoSaveFileWrapper &) = delete;
    KAutoSaveFileWrapper(KAutoSaveFileWrapper &&) = delete;
    KAutoSaveFileWrapper& operator=(KAutoSaveFileWrapper &&) = delete;

    KAutoSaveFileWrapper(::QObject * parent = nullptr);
    KAutoSaveFileWrapper(const ::QUrl & filename, ::QObject * parent = nullptr);
    bool atEnd() const override;
    qint64 bytesAvailable() const override;
    qint64 bytesToWrite() const override;
    bool canReadLine() const override;
    void childEvent(::QChildEvent * event) override;
    void close() override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    ::QString fileName() const override;
    bool isSequential() const override;
    bool open(::QFlags<QIODeviceBase::OpenModeFlag> openmode) override;
    ::QFlags<QFileDevice::Permission> permissions() const override;
    qint64 pos() const override;
    qint64 readData(char * data, qint64 maxlen) override;
    qint64 readLineData(char * data, qint64 maxlen) override;
    void releaseLock() override;
    bool reset() override;
    bool resize(qint64 sz) override;
    bool seek(qint64 offset) override;
    bool setPermissions(::QFlags<QFileDevice::Permission> permissionSpec) override;
    qint64 size() const override;
    qint64 skipData(qint64 maxSize) override;
    void timerEvent(::QTimerEvent * event) override;
    bool waitForBytesWritten(int msecs) override;
    bool waitForReadyRead(int msecs) override;
    qint64 writeData(const char * data, qint64 len) override;
    ~KAutoSaveFileWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[29] = {false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false};
};

#endif // SBK_KAutoSaveFileWrapper_H

