#ifndef SBK_KCharMacroExpanderWrapper_H
#define SBK_KCharMacroExpanderWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <kmacroexpander.h>

class KCharMacroExpanderWrapper : public KCharMacroExpander
{
public:
    KCharMacroExpanderWrapper(const KCharMacroExpanderWrapper &) = delete;
    KCharMacroExpanderWrapper& operator=(const KCharMacroExpanderWrapper &) = delete;
    KCharMacroExpanderWrapper(KCharMacroExpanderWrapper &&) = delete;
    KCharMacroExpanderWrapper& operator=(KCharMacroExpanderWrapper &&) = delete;

    KCharMacroExpanderWrapper(::QChar c = QLatin1Char('%'));
    int expandEscapedMacro(const ::QString & str, int pos, ::QStringList & ret) override;
    bool expandMacro(::QChar chr, ::QStringList & ret) override;
    int expandPlainMacro(const ::QString & str, int pos, ::QStringList & ret) override;
    ~KCharMacroExpanderWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[3] = {false, false, false};
};

#endif // SBK_KCharMacroExpanderWrapper_H

