
// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>

#define PYSIDE6_COMOPT_FULLNAME 1
#define PYSIDE6_COMOPT_COMPRESS 1
// TODO: #define PYSIDE6_COMOPT_FOLDING 1

#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "kcoreaddons_python.h"

// main header
#include "kgroupid_wrapper.h"

// Argument includes
#include <QString>
#include <kuser.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <type_traits>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_KGroupId_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::KGroupId >()))
        return -1;

    ::KGroupId *cptr{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_Size(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "KGroupId", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: KGroupId::KGroupId()
    // 1: KGroupId::KGroupId(KGroupId)
    // 2: KGroupId::KGroupId(uint)
    if (numArgs == 0) {
        overloadId = 0; // KGroupId()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<unsigned int>(), (pyArgs[0])))) {
        overloadId = 2; // KGroupId(uint)
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkKCoreAddonsTypeStructs[SBK_KGroupId_IDX]), (pyArgs[0])))) {
        overloadId = 1; // KGroupId(KGroupId)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkKCoreAddonsTypeStructs[SBK_KGroupId_IDX]);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, SbkKCoreAddonsTypeStructs[SBK_KGroupId_IDX]);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // KGroupId()
        {

            // KGroupId()
            cptr = new ::KGroupId();
            break;
        }
        case 1: // KGroupId(const KGroupId &other)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::KGroupId *cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);

            if (Shiboken::Errors::occurred() == nullptr) {
                // KGroupId(KGroupId)
                cptr = new ::KGroupId(*cppArg0);
            }
            break;
        }
        case 2: // KGroupId(unsigned int gid)
        {
            unsigned int cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);

            if (Shiboken::Errors::occurred() == nullptr) {
                // KGroupId(uint)
                cptr = new ::KGroupId(cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::KGroupId >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkKCoreAddonsTypeStructs[SBK_KGroupId_IDX]);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_KGroupIdFunc_currentEffectiveGroupId(PyObject *self)
{
    SBK_UNUSED(self)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // currentEffectiveGroupId()
        KGroupId* cppResult = new KGroupId(::KGroupId::currentEffectiveGroupId());
        pyResult = Shiboken::Object::newObject(Shiboken::Module::get(SbkKCoreAddonsTypeStructs[SBK_KGroupId_IDX]), cppResult, true, true);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_KGroupIdFunc_currentGroupId(PyObject *self)
{
    SBK_UNUSED(self)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // currentGroupId()
        KGroupId* cppResult = new KGroupId(::KGroupId::currentGroupId());
        pyResult = Shiboken::Object::newObject(Shiboken::Module::get(SbkKCoreAddonsTypeStructs[SBK_KGroupId_IDX]), cppResult, true, true);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_KGroupIdFunc_fromName(PyObject *self, PyObject *pyArg)
{
    SBK_UNUSED(self)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: static KGroupId::fromName(QString)->KGroupId
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArg)))) {
        overloadId = 0; // fromName(QString)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "fromName", errInfo, SbkKCoreAddonsTypeStructs[SBK_KGroupId_IDX]);

    // Call function/method
    {
        ::QString cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // fromName(QString)
            KGroupId* cppResult = new KGroupId(::KGroupId::fromName(cppArg0));
            pyResult = Shiboken::Object::newObject(Shiboken::Module::get(SbkKCoreAddonsTypeStructs[SBK_KGroupId_IDX]), cppResult, true, true);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_KGroupId_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_KGroupId_methods[] = {
    {"currentEffectiveGroupId", reinterpret_cast<PyCFunction>(Sbk_KGroupIdFunc_currentEffectiveGroupId), METH_NOARGS|METH_STATIC, nullptr},
    {"currentGroupId", reinterpret_cast<PyCFunction>(Sbk_KGroupIdFunc_currentGroupId), METH_NOARGS|METH_STATIC, nullptr},
    {"fromName", reinterpret_cast<PyCFunction>(Sbk_KGroupIdFunc_fromName), METH_O|METH_STATIC, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

} // extern "C"

static Py_hash_t Sbk_KGroupId_HashFunc(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::KGroupId *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkKCoreAddonsTypeStructs[SBK_KGroupId_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    return Py_hash_t(qHash(*cppSelf));
}

static int Sbk_KGroupId_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_KGroupId_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_KGroupId_Type = nullptr;
static PyTypeObject *Sbk_KGroupId_TypeF(void)
{
    return _Sbk_KGroupId_Type;
}

static PyType_Slot Sbk_KGroupId_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_hash,        reinterpret_cast<void *>(&Sbk_KGroupId_HashFunc)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_KGroupId_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_KGroupId_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_KGroupId_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_KGroupId_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_KGroupId_spec = {
    "1:KCoreAddons.KGroupId",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_KGroupId_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void KGroupId_PythonToCpp_KGroupId_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_KGroupId_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_KGroupId_PythonToCpp_KGroupId_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_KGroupId_TypeF()))
        return KGroupId_PythonToCpp_KGroupId_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *KGroupId_PTR_CppToPython_KGroupId(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    return Shiboken::Object::newObjectWithHeuristics(Sbk_KGroupId_TypeF(), const_cast<void *>(cppIn), false);

}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
#if PYSIDE6_COMOPT_COMPRESS == 0
static const char *KGroupId_SignatureStrings[] = {
    "2:KCoreAddons.KGroupId(self)",
    "1:KCoreAddons.KGroupId(self,other:KCoreAddons.KGroupId)",
    "0:KCoreAddons.KGroupId(self,gid:unsigned int)",
    "KCoreAddons.KGroupId.currentEffectiveGroupId()->KCoreAddons.KGroupId",
    "KCoreAddons.KGroupId.currentGroupId()->KCoreAddons.KGroupId",
    "KCoreAddons.KGroupId.fromName(name:QString)->KCoreAddons.KGroupId",
    "KCoreAddons.KGroupId.__hash__(self)->int",
    nullptr}; // Sentinel
#else
static constexpr size_t KGroupId_SignatureByteSize = 140;
static constexpr uint8_t KGroupId_SignatureBytes[140] = {
    0x78, 0xda, 0x33, 0xb2, 0xf2, 0x76, 0xce, 0x2f, 0x4a, 0x75, 0x4c, 0x49, 0xc9, 0xcf, 0x2b, 0xd6,
    0xf3, 0x76, 0x2f, 0xca, 0x2f, 0x2d, 0xf0, 0x4c, 0xd1, 0x28, 0x4e, 0xcd, 0x49, 0xd3, 0xe4, 0x32,
    0xc4, 0x2d, 0xa9, 0x93, 0x5f, 0x92, 0x91, 0x5a, 0x84, 0x55, 0x5e, 0x93, 0xcb, 0x00, 0x8f, 0xbe,
    0xf4, 0xcc, 0x14, 0xab, 0xd2, 0xbc, 0xe2, 0xcc, 0xf4, 0xbc, 0xd4, 0x14, 0x85, 0xcc, 0xbc, 0x12,
    0x4d, 0x2e, 0x6c, 0x6a, 0xf5, 0x92, 0x4b, 0x8b, 0x8a, 0x52, 0xf3, 0x4a, 0x5c, 0xd3, 0xd2, 0x52,
    0x93, 0x4b, 0x32, 0xcb, 0x52, 0x61, 0x66, 0x68, 0xea, 0xda, 0x61, 0x53, 0x8f, 0xd7, 0x10, 0xb2,
    0xf4, 0xa6, 0x15, 0xe5, 0xe7, 0xfa, 0x25, 0xe6, 0xa6, 0x6a, 0xe4, 0x01, 0x09, 0xab, 0xc0, 0xe0,
    0x92, 0xa2, 0xcc, 0xbc, 0x74, 0x92, 0x4c, 0x88, 0x8f, 0xcf, 0x48, 0x2c, 0xce, 0x88, 0x8f, 0x87,
    0x04, 0xa6, 0xae, 0x1d, 0xd0, 0xb3, 0x5c, 0x00, 0x63, 0x9a, 0x82, 0x23
};
#endif

PyTypeObject *init_KGroupId(PyObject *module)
{
    if (SbkKCoreAddonsTypeStructs[SBK_KGroupId_IDX].type != nullptr)
        return SbkKCoreAddonsTypeStructs[SBK_KGroupId_IDX].type;

    Shiboken::AutoDecRef Sbk_KGroupId_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_KGroupId_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "KGroupId",
        "KGroupId*",
        &Sbk_KGroupId_spec,
        &Shiboken::callCppDestructor< ::KGroupId >,
        Sbk_KGroupId_Type_bases.object(),
        0);
    auto *pyType = Sbk_KGroupId_TypeF(); // references _Sbk_KGroupId_Type
#if PYSIDE6_COMOPT_COMPRESS == 0
    InitSignatureStrings(pyType, KGroupId_SignatureStrings);
#else
    InitSignatureBytes(pyType, KGroupId_SignatureBytes, KGroupId_SignatureByteSize);
#endif
    SbkObjectType_SetPropertyStrings(pyType, Sbk_KGroupId_PropertyStrings);
    SbkKCoreAddonsTypeStructs[SBK_KGroupId_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        KGroupId_PythonToCpp_KGroupId_PTR,
        is_KGroupId_PythonToCpp_KGroupId_PTR_Convertible,
        KGroupId_PTR_CppToPython_KGroupId);

    Shiboken::Conversions::registerConverterName(converter, "KGroupId");
    Shiboken::Conversions::registerConverterName(converter, "KGroupId*");
    Shiboken::Conversions::registerConverterName(converter, "KGroupId&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::KGroupId).name());

    qRegisterMetaType< ::KGroupId *>();

    return pyType;
}
