#ifndef SBK_KJobWrapper_H
#define SBK_KJobWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <kjob.h>

namespace PySide { class DynamicQMetaObject; }

class KJobWrapper : public KJob
{
public:
    KJobWrapper(const KJobWrapper &) = delete;
    KJobWrapper& operator=(const KJobWrapper &) = delete;
    KJobWrapper(KJobWrapper &&) = delete;
    KJobWrapper& operator=(KJobWrapper &&) = delete;

    KJobWrapper(::QObject * parent = nullptr);
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool doKill() override;
    bool doResume() override;
    bool doSuspend() override;
    ::QString errorString() const override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void start() override;
    void timerEvent(::QTimerEvent * event) override;
    ~KJobWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[12] = {false, false, false, false, false, false, false, false, false, false, false, false};
};

#endif // SBK_KJobWrapper_H

