#ifndef SBK_KMacroExpanderBaseWrapper_H
#define SBK_KMacroExpanderBaseWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <kmacroexpander.h>

class KMacroExpanderBaseWrapper : public KMacroExpanderBase
{
public:
    KMacroExpanderBaseWrapper(const KMacroExpanderBaseWrapper &) = delete;
    KMacroExpanderBaseWrapper& operator=(const KMacroExpanderBaseWrapper &) = delete;
    KMacroExpanderBaseWrapper(KMacroExpanderBaseWrapper &&) = delete;
    KMacroExpanderBaseWrapper& operator=(KMacroExpanderBaseWrapper &&) = delete;

    KMacroExpanderBaseWrapper(::QChar c = QLatin1Char('%'));
    int expandEscapedMacro(const ::QString & str, int pos, ::QStringList & ret) override;
    int expandPlainMacro(const ::QString & str, int pos, ::QStringList & ret) override;
    ~KMacroExpanderBaseWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_KMacroExpanderBaseWrapper_H

