
// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>

#define PYSIDE6_COMOPT_FULLNAME 1
#define PYSIDE6_COMOPT_COMPRESS 1
// TODO: #define PYSIDE6_COMOPT_FOLDING 1

#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "kcoreaddons_python.h"

// main header
#include "kmemoryinfo_wrapper.h"

// Argument includes
#include <kmemoryinfo.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <type_traits>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_KMemoryInfo_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::KMemoryInfo >()))
        return -1;

    ::KMemoryInfo *cptr{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_Size(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "KMemoryInfo", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: KMemoryInfo::KMemoryInfo()
    // 1: KMemoryInfo::KMemoryInfo(KMemoryInfo)
    if (numArgs == 0) {
        overloadId = 0; // KMemoryInfo()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkKCoreAddonsTypeStructs[SBK_KMemoryInfo_IDX]), (pyArgs[0])))) {
        overloadId = 1; // KMemoryInfo(KMemoryInfo)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkKCoreAddonsTypeStructs[SBK_KMemoryInfo_IDX]);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, SbkKCoreAddonsTypeStructs[SBK_KMemoryInfo_IDX]);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // KMemoryInfo()
        {

            // KMemoryInfo()
            cptr = new ::KMemoryInfo();
            break;
        }
        case 1: // KMemoryInfo(const KMemoryInfo &other)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::KMemoryInfo *cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);

            if (Shiboken::Errors::occurred() == nullptr) {
                // KMemoryInfo(KMemoryInfo)
                cptr = new ::KMemoryInfo(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::KMemoryInfo >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkKCoreAddonsTypeStructs[SBK_KMemoryInfo_IDX]);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_KMemoryInfoFunc_availablePhysical(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::KMemoryInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkKCoreAddonsTypeStructs[SBK_KMemoryInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // availablePhysical()const
        quint64 cppResult = const_cast<const ::KMemoryInfo *>(cppSelf)->availablePhysical();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<quint64>(), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_KMemoryInfoFunc_buffers(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::KMemoryInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkKCoreAddonsTypeStructs[SBK_KMemoryInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // buffers()const
        quint64 cppResult = const_cast<const ::KMemoryInfo *>(cppSelf)->buffers();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<quint64>(), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_KMemoryInfoFunc_cached(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::KMemoryInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkKCoreAddonsTypeStructs[SBK_KMemoryInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // cached()const
        quint64 cppResult = const_cast<const ::KMemoryInfo *>(cppSelf)->cached();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<quint64>(), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_KMemoryInfoFunc_freePhysical(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::KMemoryInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkKCoreAddonsTypeStructs[SBK_KMemoryInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // freePhysical()const
        quint64 cppResult = const_cast<const ::KMemoryInfo *>(cppSelf)->freePhysical();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<quint64>(), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_KMemoryInfoFunc_freeSwapFile(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::KMemoryInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkKCoreAddonsTypeStructs[SBK_KMemoryInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // freeSwapFile()const
        quint64 cppResult = const_cast<const ::KMemoryInfo *>(cppSelf)->freeSwapFile();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<quint64>(), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_KMemoryInfoFunc_isNull(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::KMemoryInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkKCoreAddonsTypeStructs[SBK_KMemoryInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // isNull()const
        bool cppResult = const_cast<const ::KMemoryInfo *>(cppSelf)->isNull();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_KMemoryInfoFunc_totalPhysical(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::KMemoryInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkKCoreAddonsTypeStructs[SBK_KMemoryInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // totalPhysical()const
        quint64 cppResult = const_cast<const ::KMemoryInfo *>(cppSelf)->totalPhysical();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<quint64>(), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_KMemoryInfoFunc_totalSwapFile(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::KMemoryInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkKCoreAddonsTypeStructs[SBK_KMemoryInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // totalSwapFile()const
        quint64 cppResult = const_cast<const ::KMemoryInfo *>(cppSelf)->totalSwapFile();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<quint64>(), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_KMemoryInfo_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_KMemoryInfo_methods[] = {
    {"availablePhysical", reinterpret_cast<PyCFunction>(Sbk_KMemoryInfoFunc_availablePhysical), METH_NOARGS, nullptr},
    {"buffers", reinterpret_cast<PyCFunction>(Sbk_KMemoryInfoFunc_buffers), METH_NOARGS, nullptr},
    {"cached", reinterpret_cast<PyCFunction>(Sbk_KMemoryInfoFunc_cached), METH_NOARGS, nullptr},
    {"freePhysical", reinterpret_cast<PyCFunction>(Sbk_KMemoryInfoFunc_freePhysical), METH_NOARGS, nullptr},
    {"freeSwapFile", reinterpret_cast<PyCFunction>(Sbk_KMemoryInfoFunc_freeSwapFile), METH_NOARGS, nullptr},
    {"isNull", reinterpret_cast<PyCFunction>(Sbk_KMemoryInfoFunc_isNull), METH_NOARGS, nullptr},
    {"totalPhysical", reinterpret_cast<PyCFunction>(Sbk_KMemoryInfoFunc_totalPhysical), METH_NOARGS, nullptr},
    {"totalSwapFile", reinterpret_cast<PyCFunction>(Sbk_KMemoryInfoFunc_totalSwapFile), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

// Rich comparison
static PyObject * Sbk_KMemoryInfo_richcompare(PyObject *self, PyObject *pyArg, int op)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::KMemoryInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkKCoreAddonsTypeStructs[SBK_KMemoryInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    switch (op) {
        case Py_NE:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkKCoreAddonsTypeStructs[SBK_KMemoryInfo_IDX]), (pyArg)))) {
                // operator!=(const KMemoryInfo &other) const
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::KMemoryInfo *cppArg0;
                pythonToCpp(pyArg, &cppArg0);
                bool cppResult = cppSelf != (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_True;
                Py_INCREF(pyResult);
            }

            break;
        case Py_EQ:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkKCoreAddonsTypeStructs[SBK_KMemoryInfo_IDX]), (pyArg)))) {
                // operator==(const KMemoryInfo &other) const
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::KMemoryInfo *cppArg0;
                pythonToCpp(pyArg, &cppArg0);
                bool cppResult = cppSelf == (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_False;
                Py_INCREF(pyResult);
            }

            break;
        default:
            // PYSIDE-74: By default, we redirect to object's tp_richcompare (which is `==`, `!=`).
            return FallbackRichCompare(self, pyArg, op);
    }

    return Shiboken::returnFromRichCompare(pyResult);
}

} // extern "C"

static int Sbk_KMemoryInfo_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_KMemoryInfo_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_KMemoryInfo_Type = nullptr;
static PyTypeObject *Sbk_KMemoryInfo_TypeF(void)
{
    return _Sbk_KMemoryInfo_Type;
}

static PyType_Slot Sbk_KMemoryInfo_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_KMemoryInfo_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_KMemoryInfo_clear)},
    {Py_tp_richcompare, reinterpret_cast<void *>(Sbk_KMemoryInfo_richcompare)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_KMemoryInfo_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_KMemoryInfo_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_KMemoryInfo_spec = {
    "1:KCoreAddons.KMemoryInfo",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_KMemoryInfo_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void KMemoryInfo_PythonToCpp_KMemoryInfo_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_KMemoryInfo_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_KMemoryInfo_PythonToCpp_KMemoryInfo_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_KMemoryInfo_TypeF()))
        return KMemoryInfo_PythonToCpp_KMemoryInfo_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *KMemoryInfo_PTR_CppToPython_KMemoryInfo(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    return Shiboken::Object::newObjectWithHeuristics(Sbk_KMemoryInfo_TypeF(), const_cast<void *>(cppIn), false);

}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
#if PYSIDE6_COMOPT_COMPRESS == 0
static const char *KMemoryInfo_SignatureStrings[] = {
    "1:KCoreAddons.KMemoryInfo(self)",
    "0:KCoreAddons.KMemoryInfo(self,other:KCoreAddons.KMemoryInfo)",
    "KCoreAddons.KMemoryInfo.availablePhysical(self)->quint64",
    "KCoreAddons.KMemoryInfo.buffers(self)->quint64",
    "KCoreAddons.KMemoryInfo.cached(self)->quint64",
    "KCoreAddons.KMemoryInfo.freePhysical(self)->quint64",
    "KCoreAddons.KMemoryInfo.freeSwapFile(self)->quint64",
    "KCoreAddons.KMemoryInfo.isNull(self)->bool",
    "KCoreAddons.KMemoryInfo.totalPhysical(self)->quint64",
    "KCoreAddons.KMemoryInfo.totalSwapFile(self)->quint64",
    "KCoreAddons.KMemoryInfo.__ne__(self,other:KCoreAddons.KMemoryInfo)->bool",
    "KCoreAddons.KMemoryInfo.__eq__(self,other:KCoreAddons.KMemoryInfo)->bool",
    nullptr}; // Sentinel
#else
static constexpr size_t KMemoryInfo_SignatureByteSize = 161;
static constexpr uint8_t KMemoryInfo_SignatureBytes[161] = {
    0x78, 0xda, 0x95, 0x91, 0x41, 0x0a, 0xc2, 0x30, 0x10, 0x45, 0xf7, 0x3d, 0x89, 0x05, 0x2d, 0x0a,
    0xe2, 0xc2, 0x85, 0x20, 0x82, 0x20, 0x45, 0x11, 0x3c, 0x40, 0x98, 0x34, 0x13, 0x12, 0x18, 0x33,
    0x36, 0x49, 0x95, 0xde, 0x5e, 0x54, 0x70, 0x17, 0x4d, 0xd6, 0xff, 0xfd, 0xf9, 0x0f, 0x66, 0xb1,
    0x6e, 0x77, 0xec, 0x71, 0xab, 0x14, 0xbb, 0xd0, 0xb4, 0x47, 0xbc, 0xb2, 0x1f, 0x0f, 0x4e, 0xf3,
    0x24, 0x20, 0xe9, 0xba, 0x9a, 0xff, 0xcc, 0xa7, 0x1c, 0x0d, 0xfa, 0x14, 0x52, 0x57, 0x89, 0xa0,
    0x81, 0x3b, 0x58, 0x02, 0x49, 0x78, 0x36, 0x63, 0xb0, 0x1d, 0xd0, 0x67, 0x6d, 0xb6, 0xe9, 0x07,
    0xeb, 0xe2, 0x6a, 0x99, 0x2c, 0xca, 0x41, 0x6b, 0xf4, 0x21, 0x17, 0xef, 0xa0, 0x33, 0xa8, 0x72,
    0x69, 0xed, 0xb1, 0x58, 0xe8, 0xd5, 0xb9, 0x3c, 0xe0, 0xb6, 0xb7, 0x84, 0xb9, 0x1d, 0x1b, 0x4e,
    0x03, 0x7d, 0x17, 0x24, 0x33, 0x25, 0xd1, 0xc8, 0x11, 0xa8, 0xd4, 0xe9, 0x5d, 0x2a, 0x95, 0x12,
    0xc2, 0xa1, 0x10, 0x39, 0x5f, 0xfd, 0xa3, 0x2c, 0x04, 0xf6, 0x45, 0x87, 0x9e, 0xae, 0x82, 0xe7,
    0x61
};
#endif

PyTypeObject *init_KMemoryInfo(PyObject *module)
{
    if (SbkKCoreAddonsTypeStructs[SBK_KMemoryInfo_IDX].type != nullptr)
        return SbkKCoreAddonsTypeStructs[SBK_KMemoryInfo_IDX].type;

    Shiboken::AutoDecRef Sbk_KMemoryInfo_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_KMemoryInfo_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "KMemoryInfo",
        "KMemoryInfo*",
        &Sbk_KMemoryInfo_spec,
        &Shiboken::callCppDestructor< ::KMemoryInfo >,
        Sbk_KMemoryInfo_Type_bases.object(),
        0);
    auto *pyType = Sbk_KMemoryInfo_TypeF(); // references _Sbk_KMemoryInfo_Type
#if PYSIDE6_COMOPT_COMPRESS == 0
    InitSignatureStrings(pyType, KMemoryInfo_SignatureStrings);
#else
    InitSignatureBytes(pyType, KMemoryInfo_SignatureBytes, KMemoryInfo_SignatureByteSize);
#endif
    SbkObjectType_SetPropertyStrings(pyType, Sbk_KMemoryInfo_PropertyStrings);
    SbkKCoreAddonsTypeStructs[SBK_KMemoryInfo_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        KMemoryInfo_PythonToCpp_KMemoryInfo_PTR,
        is_KMemoryInfo_PythonToCpp_KMemoryInfo_PTR_Convertible,
        KMemoryInfo_PTR_CppToPython_KMemoryInfo);

    Shiboken::Conversions::registerConverterName(converter, "KMemoryInfo");
    Shiboken::Conversions::registerConverterName(converter, "KMemoryInfo*");
    Shiboken::Conversions::registerConverterName(converter, "KMemoryInfo&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::KMemoryInfo).name());

    qRegisterMetaType< ::KMemoryInfo *>();

    return pyType;
}
