#ifndef SBK_KPluginFactoryWrapper_H
#define SBK_KPluginFactoryWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <kpluginfactory.h>

namespace PySide { class DynamicQMetaObject; }

class KPluginFactoryWrapper : public KPluginFactory
{
public:
    KPluginFactoryWrapper(const KPluginFactoryWrapper &) = delete;
    KPluginFactoryWrapper& operator=(const KPluginFactoryWrapper &) = delete;
    KPluginFactoryWrapper(KPluginFactoryWrapper &&) = delete;
    KPluginFactoryWrapper& operator=(KPluginFactoryWrapper &&) = delete;

    KPluginFactoryWrapper();
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void timerEvent(::QTimerEvent * event) override;
    ~KPluginFactoryWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[7] = {false, false, false, false, false, false, false};
};

#endif // SBK_KPluginFactoryWrapper_H

