#ifndef SBK_KProcessWrapper_H
#define SBK_KProcessWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <kprocess.h>

namespace PySide { class DynamicQMetaObject; }

class KProcessWrapper : public KProcess
{
public:
    KProcessWrapper(const KProcessWrapper &) = delete;
    KProcessWrapper& operator=(const KProcessWrapper &) = delete;
    KProcessWrapper(KProcessWrapper &&) = delete;
    KProcessWrapper& operator=(KProcessWrapper &&) = delete;

    KProcessWrapper(::QObject * parent = nullptr);
    bool atEnd() const override;
    qint64 bytesAvailable() const override;
    qint64 bytesToWrite() const override;
    bool canReadLine() const override;
    void childEvent(::QChildEvent * event) override;
    void close() override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    bool isSequential() const override;
    bool open(::QFlags<QIODeviceBase::OpenModeFlag> mode = QIODeviceBase::OpenModeFlag::ReadWrite) override;
    qint64 pos() const override;
    qint64 readData(char * data, qint64 maxlen) override;
    qint64 readLineData(char * data, qint64 maxlen) override;
    bool reset() override;
    bool seek(qint64 pos) override;
    qint64 size() const override;
    qint64 skipData(qint64 maxSize) override;
    void timerEvent(::QTimerEvent * event) override;
    bool waitForBytesWritten(int msecs = 30000) override;
    bool waitForReadyRead(int msecs = 30000) override;
    qint64 writeData(const char * data, qint64 len) override;
    ~KProcessWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[24] = {false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false};
};

#endif // SBK_KProcessWrapper_H

