#ifndef SBK_KWordMacroExpanderWrapper_H
#define SBK_KWordMacroExpanderWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <kmacroexpander.h>

class KWordMacroExpanderWrapper : public KWordMacroExpander
{
public:
    KWordMacroExpanderWrapper(const KWordMacroExpanderWrapper &) = delete;
    KWordMacroExpanderWrapper& operator=(const KWordMacroExpanderWrapper &) = delete;
    KWordMacroExpanderWrapper(KWordMacroExpanderWrapper &&) = delete;
    KWordMacroExpanderWrapper& operator=(KWordMacroExpanderWrapper &&) = delete;

    KWordMacroExpanderWrapper(::QChar c = QLatin1Char('%'));
    int expandEscapedMacro(const ::QString & str, int pos, ::QStringList & ret) override;
    bool expandMacro(const ::QString & str, ::QStringList & ret) override;
    int expandPlainMacro(const ::QString & str, int pos, ::QStringList & ret) override;
    ~KWordMacroExpanderWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[3] = {false, false, false};
};

#endif // SBK_KWordMacroExpanderWrapper_H

